Index: issm/trunk/src/m/contrib/defleurian/paraview/enveloppeVTK.py
===================================================================
--- issm/trunk/src/m/contrib/defleurian/paraview/enveloppeVTK.py	(revision 23389)
+++ issm/trunk/src/m/contrib/defleurian/paraview/enveloppeVTK.py	(revision 23394)
@@ -9,11 +9,11 @@
 	creates a directory with the vtk files for displays in paraview
 	(only work for triangle and wedges based on their number of nodes)
-	
-	Give only the results for nw but could be extended to geometry, mask... 
-	
-	input: filename   destination 
+
+	Give only the results for nw but could be extended to geometry, mask...
+
+	input: filename   destination
 	(string)
 	------------------------------------------------------------------
-model      this is md 
+model      this is md
 	------------------------------------------------------------------
 	By default only the results are exported, you can add whichever
@@ -40,22 +40,38 @@
 		os.mkdir(filename)
 
-	IsEnveloppe=np.where(model.mesh.vertexonbase | model.mesh.vertexonsurface)
-	#get the element related variables
+	# {{{get the element related variables
 	if 'z' in dict.keys(model.mesh.__dict__):
-		points=np.column_stack((model.mesh.x,model.mesh.y,model.mesh.z))
-		num_of_elt=np.size(np.isnan(model.mesh.lowerelements))+np.size(np.isnan(model.mesh.upperelements))
-		low_elt_num=np.size(np.isnan(model.mesh.lowerelements))
-		top_elt_num=np.size(np.isnan(model.mesh.upperelements))
+		is_enveloppe=np.logical_or(model.mesh.vertexonbase,model.mesh.vertexonsurface)
+		enveloppe_index=np.where(is_enveloppe)[0]
+		convert_index=np.nan*np.ones(np.shape(model.mesh.x))
+		convert_index=np.asarray([[i,np.where(enveloppe_index==i)[0][0]] for i,val in enumerate(convert_index) if any(enveloppe_index==i)])
+		points=np.column_stack((model.mesh.x[enveloppe_index],
+														model.mesh.y[enveloppe_index],
+														model.mesh.z[enveloppe_index]))
+		low_elt_num=np.size(np.where(np.isnan(model.mesh.lowerelements)))
+		top_elt_num=np.size(np.where(np.isnan(model.mesh.upperelements)))
+		num_of_elt=low_elt_num+top_elt_num
+		connect=model.mesh.elements[np.where(is_enveloppe[model.mesh.elements-1])].reshape(int(num_of_elt),3)-1
+		for elt in range(0, num_of_elt):
+			connect[elt,0]=convert_index[np.where(convert_index==connect[elt,0])[0],1][0]
+			connect[elt,1]=convert_index[np.where(convert_index==connect[elt,1])[0],1][0]
+			connect[elt,2]=convert_index[np.where(convert_index==connect[elt,2])[0],1][0]
+
 	else:
-		points=np.column_stack((model.mesh.x,model.mesh.y,np.zeros(np.shape(model.mesh.x))))
+		points=np.column_stack((model.mesh.x,
+														model.mesh.y,
+														np.zeros(np.shape(model.mesh.x))))
 		num_of_elt=np.shape(model.mesh.elements)[0]
-		
-	num_of_points=np.size(points)[0]
-	dim=np.size(points)[1]
-	point_per_elt=np.shape(model.mesh.elements)[1]
-		
+		connect=model.mesh.elements-1
+		enveloppe_index=np.arange(0,np.size(model.mesh.x))
+
+	every_nodes=np.size(model.mesh.x)
+	num_of_points=np.size(enveloppe_index)
+	dim=3
+	point_per_elt=3
 	celltype=5 #triangles
-	
-	#this is the result structure
+
+	# }}}
+	# {{{this is the result structure
 	res_struct=model.results
 	if (len(res_struct.__dict__)>0):
@@ -64,13 +80,14 @@
 		num_of_sols=len(solnames)
 		num_of_timesteps=1
-		#%building solutionstructure 
+		#%building solutionstructure
 		for solution in solnames:
 			#looking for multiple time steps
 			if (np.size(res_struct.__dict__[solution])>num_of_timesteps):
 				num_of_timesteps=np.size(res_struct.__dict__[solution])
-				num_of_timesteps=int(num_of_timesteps)+1
+				num_of_timesteps=int(num_of_timesteps)
 	else:
 		num_of_timesteps=1
-
+	# }}}
+	# {{{write header and mesh
 	for step in range(0,num_of_timesteps):
 		timestep=step
@@ -83,17 +100,12 @@
 		for point in points:
 			fid.write('%f %f %f \n'%(point[0], point[1], point[2]))
-			
+
 		fid.write('CELLS %d %d\n' %(num_of_elt, num_of_elt*(point_per_elt+1)))
 
-		# 	if exist('low_elt_num')
-		# triaconnect=zeros(num_of_elt,3);
-		# triaconnect(1:low_elt_num,:)=model.mesh.elements(find(isnan(model.mesh.lowerelements)),1:3);
-		# upshift=-min(min(model.mesh.elements(find(isnan(model.mesh.upperelements)),4:6)))+1+max(max(model.mesh.elements(find(isnan(model.mesh.lowerelements)),1:3)));
-		# triaconnect(1+low_elt_num:num_of_elt,:)=model.mesh.elements(find(isnan(model.mesh.upperelements)),4:6)+upshift;
-		# fprintf(fid,s,[(3)*ones(num_of_elt,1) triaconnect-1]');
 		for elt in range(0, num_of_elt):
-		
-			fid.write('3 %d %d %d\n' %(model.mesh.elements[elt,0]-1,model.mesh.elements[elt,1]-1,model.mesh.elements[elt,2]-1))
-		
+			fid.write('3 %d %d %d\n' %(connect[elt,0],
+																 connect[elt,1],
+																 connect[elt,2]))
+
 		fid.write('CELL_TYPES %d\n' %num_of_elt)
 		for elt in range(0, num_of_elt):
@@ -101,6 +113,6 @@
 
 		fid.write('POINT_DATA %s \n' %str(num_of_points))
-	
-		#loop over the different solution structures
+		# }}}
+		# {{{loop over the different solution structures
 		if 'solnames' in locals():
 			for sol in solnames:
@@ -110,8 +122,8 @@
 				else:
 					timestep = np.size(res_struct.__dict__[sol])
-				
+
 				#getting the  fields in the solution
 				if(np.size(res_struct.__dict__[sol])>1):
-					fieldnames=dict.keys(res_struct.__dict__[sol].__getitem__(timestep-1).__dict__)
+					fieldnames=dict.keys(res_struct.__dict__[sol].__getitem__(timestep).__dict__)
 				else:
 					fieldnames=dict.keys(res_struct.__dict__[sol].__dict__)
@@ -119,39 +131,40 @@
 				for field in fieldnames:
 					if(np.size(res_struct.__dict__[sol])>1):
-						fieldstruct=res_struct.__dict__[sol].__getitem__(timestep-1).__dict__[field]
+						fieldstruct=res_struct.__dict__[sol].__getitem__(timestep).__dict__[field]
 					else:
 						fieldstruct=res_struct.__dict__[sol].__dict__[field]
 
-					if ((np.size(fieldstruct))==num_of_points):
+					if ((np.size(fieldstruct))==every_nodes):
 						fid.write('SCALARS %s float 1 \n' % field)
 						fid.write('LOOKUP_TABLE default\n')
 						for node in range(0,num_of_points):
 							#paraview does not like NaN, replacing
-							if np.isnan(fieldstruct[node]):
+							if np.isnan(fieldstruct[enveloppe_index[node]]):
 								fid.write('%e\n' % -9999.9999)
 							#also checking for verry small value that mess up
-							elif (abs(fieldstruct[node])<1.0e-20):
+							elif (abs(fieldstruct[enveloppe_index[node]])<1.0e-20):
 								fid.write('%e\n' % 0.0)
 							else:
-								fid.write('%e\n' % fieldstruct[node])
-					
-		#loop on arguments, if something other than result is asked, do
-		#it now
+								fid.write('%e\n' % fieldstruct[enveloppe_index[node]])
+		# }}}
+		# {{{loop on arguments, if something other than result is asked, do it now
+
 		for other in args:
 			other_struct=model.__dict__[other]
 			othernames=(dict.keys(other_struct.__dict__))
 			for field in othernames:
-#				fprintf(fid,s,res_struct.(fieldnames{k})(IsEnveloppe));
-				if ((np.size(other_struct.__dict__[field]))==num_of_points):
+				if ((np.size(other_struct.__dict__[field]))==every_nodes):
 					fid.write('SCALARS %s float 1 \n' % field)
 					fid.write('LOOKUP_TABLE default\n')
 					for node in range(0,num_of_points):
 						#paraview does not like NaN, replacing
-						if np.isnan(other_struct.__dict__[field][node]):
+						if np.isnan(other_struct.__dict__[field][enveloppe_index[node]]):
 							fid.write('%e\n' % -9999.9999)
 						#also checking for verry small value that mess up
-						elif (abs(other_struct.__dict__[field][node])<1.0e-20):
+						elif (abs(other_struct.__dict__[field][enveloppe_index[node]])<1.0e-20):
 							fid.write('%e\n' % 0.0)
 						else:
-							fid.write('%e\n' % other_struct.__dict__[field][node])
+							fid.write('%e\n' % other_struct.__dict__[field][enveloppe_index[node]])
+
+			# }}}
 	fid.close();
Index: issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py
===================================================================
--- issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py	(revision 23389)
+++ issm/trunk/src/m/contrib/defleurian/paraview/exportVTK.py	(revision 23394)
@@ -9,11 +9,11 @@
 	creates a directory with the vtk files for displays in paraview
 	(only work for triangle and wedges based on their number of nodes)
-	
-	Give only the results for nw but could be extended to geometry, mask... 
-	
-	input: filename   destination 
+
+	Give only the results for nw but could be extended to geometry, mask...
+
+	input: filename   destination
 	(string)
 	------------------------------------------------------------------
-model      this is md 
+model      this is md
 	------------------------------------------------------------------
 	By default only the results are exported, you can add whichever
@@ -67,5 +67,5 @@
 		num_of_sols=len(solnames)
 		num_of_timesteps=1
-		#%building solutionstructure 
+		#%building solutionstructure
 		for solution in solnames:
 			#looking for multiple time steps
@@ -91,7 +91,7 @@
 			for point in points:
 				fid.write('%f %f %f \n'%(point[0], point[1], point[2]))
-			
+
 		fid.write('CELLS %d %d\n' %(num_of_elt, num_of_elt*(point_per_elt+1)))
-		
+
 		if point_per_elt==3:
 			for elt in range(0, num_of_elt):
@@ -117,5 +117,5 @@
 				else:
 					timestep = np.size(res_struct.__dict__[sol])
-				
+
 				#getting the  fields in the solution
 				if(np.size(res_struct.__dict__[sol])>1):
@@ -187,11 +187,14 @@
 					# reloaded variable are generally of dim 2
 					elif np.shape(other_struct.__dict__[field])[0]==num_of_points:
+						# we want only vector
+						if np.shape(other_struct.__dict__[field])[1]==1:
 							fid.write('SCALARS %s float 1 \n' % field)
 							fid.write('LOOKUP_TABLE default\n')
 							for node in range(0,num_of_points):
 								#paraview does not like NaN, replacing
+								print other_struct.__dict__[field][node]
 								if np.isnan(other_struct.__dict__[field][node]):
 									fid.write('%e\n' % -9999.9999)
-								#also checking for verry small value that mess up
+									#also checking for verry small value that mess up
 								elif (abs(other_struct.__dict__[field][node])<1.0e-20):
 									fid.write('%e\n' % 0.0)
Index: issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.m
===================================================================
--- issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.m	(revision 23389)
+++ issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.m	(revision 23394)
@@ -23,5 +23,5 @@
 	resolution=getfieldvalue(options,'resolution')*1000;
 
-	%initialize mesh: 
+	%initialize mesh:
 	mesh=mesh3dsurface;
 
@@ -97,5 +97,5 @@
 		end
 		fprintf(fid,'};\n');
-		
+
 		fclose(fid);
 		% }}}
@@ -111,5 +111,5 @@
 	end
 	if isempty(gmshpath),
-		error('gmt not found, make sure it is properly installed');
+		error('gmsh not found, make sure it is properly installed');
 	end
 
@@ -160,20 +160,20 @@
 	mesh.numberofelements=fscanf(fid,'%i',1);
 	A=fscanf(fid,'%i %i %i %i %i %i %i %i',[8 mesh.numberofelements]);
-	mesh.elements=A(6:8,:)'; 
+	mesh.elements=A(6:8,:)';
 	A=fscanf(fid,'%s',1);
 	if ~strcmp(A,'$EndElements'),
 		error(['Expecting $EndElements (' A ')']);
 	end
-	fclose(fid); 
+	fclose(fid);
 	%}}}
 
-	%figure out other fields in mesh3dsurface: 
+	%figure out other fields in mesh3dsurface:
 	mesh.r=sqrt(mesh.x.^2+mesh.y.^2+mesh.z.^2);
 	mesh.lat = asin(mesh.z./mesh.r)/pi*180;
 	mesh.long = atan2(mesh.y,mesh.x)/pi*180;
 
-	%erase files: 
+	%erase files:
 	system('rm -rf sphere.geo sphere.msh sphere.pos');
 
-	%return mesh: 
+	%return mesh:
 	return;
Index: issm/trunk/src/m/mesh/triangle.py
===================================================================
--- issm/trunk/src/m/mesh/triangle.py	(revision 23389)
+++ issm/trunk/src/m/mesh/triangle.py	(revision 23394)
@@ -2,7 +2,7 @@
 import numpy as np
 from mesh2d import mesh2d
-from Triangle import Triangle
 from NodeConnectivity import NodeConnectivity
 from ElementConnectivity import ElementConnectivity
+from Triangle_python import Triangle_python
 import MatlabFuncs as m
 
@@ -50,5 +50,5 @@
 	#Mesh using Triangle
 	md.mesh=mesh2d()
-	md.mesh.elements,md.mesh.x,md.mesh.y,md.mesh.segments,md.mesh.segmentmarkers=Triangle(domainname,riftname,area)
+	md.mesh.elements,md.mesh.x,md.mesh.y,md.mesh.segments,md.mesh.segmentmarkers=Triangle_python(domainname,riftname,area)
 	md.mesh.elements=md.mesh.elements.astype(int)
 	md.mesh.segments=md.mesh.segments.astype(int)
Index: issm/trunk/src/m/mesh/triangle2dvertical.m
===================================================================
--- issm/trunk/src/m/mesh/triangle2dvertical.m	(revision 23389)
+++ issm/trunk/src/m/mesh/triangle2dvertical.m	(revision 23394)
@@ -25,5 +25,5 @@
 
 %Mesh using Triangle
-[elements,x,z,segments,segmentmarkers]=Triangle(domainname,'',area);
+[elements,x,z,segments,segmentmarkers]=Triangle_matlab(domainname,'',area);
 
 %check that all the created nodes belong to at least one element
Index: issm/trunk/src/m/modules/Chaco.py
===================================================================
--- issm/trunk/src/m/modules/Chaco.py	(revision 23389)
+++ issm/trunk/src/m/modules/Chaco.py	(revision 23394)
@@ -5,5 +5,5 @@
 
    Usage:
-      [assgn] = Chaco(A,vwgts,ewgts,x,y,z,options,nparts,goal);
+      assgn = Chaco(A,vwgts,ewgts,x,y,z,options,nparts,goal);
 
    A:			Input adjacency matrix
Index: issm/trunk/src/m/modules/MeshPartition.m
===================================================================
--- issm/trunk/src/m/modules/MeshPartition.m	(revision 23389)
+++ issm/trunk/src/m/modules/MeshPartition.m	(revision 23394)
@@ -3,5 +3,5 @@
 %
 %	   Usage:
-%			[element_partitioning,node_partitioning]=MeshPartition(md,numpartitions)");
+%			[element_partitioning,node_partitioning]=MeshPartition(md,numpartitions);
 %
 %	   element_partitioning: Vector of partitioning area numbers, for every element.
@@ -35,3 +35,3 @@
 
 % Call mex module
-[element_partitioning, node_partitioning] = MeshPartition_matlab(numberofvertices,elements,numberofvertices2d,elements2d,numberoflayers,meshelementtype,numpartitions);
+[element_partitioning, node_partitioning] = MeshPartition_matlab(numberofvertices,elements,numberofvertices2d,elements2d,numberoflayers,elementtype,numpartitions);
Index: issm/trunk/src/m/modules/MeshPartition.py
===================================================================
--- issm/trunk/src/m/modules/MeshPartition.py	(revision 23389)
+++ issm/trunk/src/m/modules/MeshPartition.py	(revision 23394)
@@ -9,5 +9,5 @@
 
 	   Usage:
-			[element_partitioning,node_partitioning]=MeshPartition(md.mesh,numpartitions)")
+			[element_partitioning,node_partitioning]=MeshPartition(md.mesh,numpartitions)
 
 	   element_partitioning: Vector of partitioning area numbers, for every element.
@@ -38,5 +38,5 @@
 
 	#Call module
-	[element_partitioning, node_partitioning] = MeshPartition_python(numberofvertices, elements, numberofvertices2d, elements2d, numberoflayers, meshelementtype, numpartitions)
+	[element_partitioning, node_partitioning] = MeshPartition_python(numberofvertices, elements, numberofvertices2d, elements2d, numberoflayers,elementtype, numpartitions)
 
 	return [element_partitioning, node_partitioning]
Index: issm/trunk/src/m/partition/AreaAverageOntoPartition.py
===================================================================
--- issm/trunk/src/m/partition/AreaAverageOntoPartition.py	(revision 23394)
+++ issm/trunk/src/m/partition/AreaAverageOntoPartition.py	(revision 23394)
@@ -0,0 +1,59 @@
+import numpy as np
+
+def AreaAverageOntoPartition(md,vector,layer=None):
+	'''AREAAVERAGEONTOPARTITION 
+   compute partition values for a certain vector expressed on the vertices of the mesh.
+   Use area weighted average.
+
+   Usage:
+      average=AreaAverageOntoPartition(md,vector)
+      average=AreaAverageOntoPartition(md,vector,layer) #if in 3D, chose which layer is partitioned
+'''
+	#some checks
+	if len(np.shape(md.mesh)) == 3:
+		if layer == None:
+			raise RuntimeError('AreaAverageOntoPartition: layer should be provided onto which Area Averaging occurs')
+		
+		#save 3D model
+		md3d = md
+
+		md.mesh.elements = md.mesh.elements2d
+		md.mesh.x = md.mesh.x2d
+		md.mesh.y = md.mesh.y2d
+		md.mesh.numberofvertices = md.mesh.numberofvertices2d
+		md.mesh.numberofelements = md.mesh.numberofelements2d
+		md.qmu.vertex_weight = []
+		md.mesh.vertexconnectivity = []
+
+		#run connectivity routine
+		md = adjacency(md)
+
+		#finally, project vector: 
+		vector = project2d(md3d,vector,layer)
+		md.qmu.partition = project2d(md3d,md3d.qmu.partition,layer)
+
+
+	#ok, first check that part is Matlab indexed
+	#part = md.qmu.partition
+
+	#some check: 
+	if md.qmu.numberofpartitions != max(md.qmu.partition):
+		raise RuntimeError('AreaAverageOntoPartition error message: ''npart'' should be equal to max(md.qmu.partition)')
+
+
+	#initialize output
+	partvector = np.zeros((max(md.qmu.partition),))
+
+	#start weight average
+	weightedvector = vector*md.qmu.vertex_weight
+	for i in range(max(md.qmu.partition)):
+		pos=np.where(md.qmu.partition==i)
+		partvector[i]=sum(weightedvector[pos])/sum(md.qmu.vertex_weight[pos])
+
+
+	#in 3D, restore 3D model:
+	if len(np.shape(md.mesh)) == 3:
+		md = md3d
+
+	return partvector
+
Index: issm/trunk/src/m/partition/partitioner.py
===================================================================
--- issm/trunk/src/m/partition/partitioner.py	(revision 23389)
+++ issm/trunk/src/m/partition/partitioner.py	(revision 23394)
@@ -3,8 +3,9 @@
 import MatlabFuncs as m
 from adjacency import *
-#from Chaco import *
+from Chaco import *
 #from Scotch import *
-#from MeshPartition import *
+from MeshPartition import *
 from project3d import *
+from mesh2d import *
 
 def partitioner(md,*varargin):
@@ -60,27 +61,28 @@
 
 	if m.strcmpi(package,'chaco'):
-		raise RuntimeError('Chaco is not currently supported for this function')
+		#raise RuntimeError('Chaco is not currently supported for this function')
 
 		#  default method (from chaco.m)
-		#method=np.array([1,1,0,0,1,1,50,0,.001,7654321]).reshape(-1,1)
-		#method[0]=3    #  global method (3=inertial (geometric))
-		#method[2]=0    #  vertex weights (0=off, 1=on)
+		method=np.array([1,1,0,0,1,1,50,0,.001,7654321])
+		method[0]=3    #  global method (3=inertial (geometric))
+		method[2]=0    #  vertex weights (0=off, 1=on)
 
 		#specify bisection
-		#method[5]=options.getfieldvalue('section')#  ndims (1=bisection, 2=quadrisection, 3=octasection)
+		method[5]=options.getfieldvalue('section')#  ndims (1=bisection, 2=quadrisection, 3=octasection)
 
 		#are we using weights? 
-		#if m.strcmpi(options.getfieldvalue('weighting'),'on'):
-			#weights=np.floor(md.qmu.vertex_weight/min(md.qmu.vertex_weight))
-			#method[2]=1
-		#else:
-			#weights=[]
+		if m.strcmpi(options.getfieldvalue('weighting'),'on'):
+			weights=np.floor(md.qmu.vertex_weight/min(md.qmu.vertex_weight))
+			method[2]=1
+		else:
+			weights=[]
 	
+		method = method.reshape(-1,1)	# transpose to 1x10 instead of 10
+
 		#  partition into nparts
-		#if isinstance(md.mesh,mesh2d):
-			#part=Chaco(md.qmu.adjacency,weights,[],md.mesh.x, md.mesh.y,np.zeros((md.mesh.numberofvertices,)),method,npart,[]).T+1 #index partitions from 1 up. like metis.
-		#else:
-			#part=Chaco(md.qmu.adjacency,weights,[],md.mesh.x, md.mesh.y,md.mesh.z,method,npart,[]).T+1 #index partitions from 1 up. like metis.
-	
+		if isinstance(md.mesh,mesh2d):
+			part=np.array(Chaco(md.qmu.adjacency,weights,np.array([]),md.mesh.x, md.mesh.y,np.zeros((md.mesh.numberofvertices,)),method,npart,np.array([]))).T+1 #index partitions from 1 up. like metis.
+		else:
+			part=np.array(Chaco(md.qmu.adjacency,weights,np.array([]),md.mesh.x, md.mesh.y,md.mesh.z,method,npart,np.array([]))).T+1 #index partitions from 1 up. like metis.
 	
 	elif m.strcmpi(package,'scotch'):
Index: issm/trunk/src/m/plot/applyoptions.m
===================================================================
--- issm/trunk/src/m/plot/applyoptions.m	(revision 23389)
+++ issm/trunk/src/m/plot/applyoptions.m	(revision 23394)
@@ -142,4 +142,6 @@
 	if exist(options,'colorbarcornerposition'),
 		c=colorbar(getfieldvalue(options,'colorbarcornerposition'),'peer',gca);
+	elseif exist(options,'colorbarpos') & ischar(getfieldvalue(options,'colorbarpos')),
+		c=colorbar(getfieldvalue(options,'colorbarpos'));
 	else 
 		c=colorbar('peer',gca);
@@ -151,5 +153,5 @@
 		set(c,'Ylim',lim);
 	end
-	if exist(options,'colorbarpos'),
+	if exist(options,'colorbarpos') & isnumeric(getfieldvalue(options,'colorbarpos')),
 		set(c,'Position',getfieldvalue(options,'colorbarpos'));
 	end
Index: issm/trunk/src/m/plot/googlemaps.m
===================================================================
--- issm/trunk/src/m/plot/googlemaps.m	(revision 23389)
+++ issm/trunk/src/m/plot/googlemaps.m	(revision 23394)
@@ -123,5 +123,20 @@
 			'&scale=' num2str(scale)];
 		url = ['http://maps.google.com/maps/api/staticmap?' params];
-		[X, map]=imread(url,'png');
+		count = 0;
+		countmax = 10;
+		while(true)
+			try,
+				[X, map]=imread(url,'png');
+				break;
+			catch me,
+				count = count+1;
+				disp(['Failed, trying again... (' num2str(countmax-count) ' more attempts)']);
+				pause(.3);
+				if count>countmax,
+					disp('Giving up...');
+					rethrow(me);
+				end
+			end
+		end
 		X=ind2rgb(X,map);
 		indx1 = floor(x*width)+1;
Index: issm/trunk/src/m/qmu/dakota_in_write.py
===================================================================
--- issm/trunk/src/m/qmu/dakota_in_write.py	(revision 23389)
+++ issm/trunk/src/m/qmu/dakota_in_write.py	(revision 23394)
@@ -62,5 +62,5 @@
 	filei2=fullfile(pathstr,name+ext)
 
-	print 'Opening Dakota input file \''+filei2 + '\''
+	print 'Opening Dakota input file \''+filei2 + '\'.'
 	try:
 		with open(filei2,'w+') as fidi:
Index: issm/trunk/src/m/qmu/dakota_out_parse.py
===================================================================
--- issm/trunk/src/m/qmu/dakota_out_parse.py	(revision 23389)
+++ issm/trunk/src/m/qmu/dakota_out_parse.py	(revision 23394)
@@ -241,4 +241,15 @@
 	dmax95 =prctile_issm(data,95,0)
 
+	# Note: the following line may cause the following warning
+	#	(should not crash or invalidate results) when one of
+	#	the inputs does not change with respect to the
+	#	other/s causing an internal divide-by-zero error
+
+	#/usr/local/lib/python2.7/dist-packages/numpy/lib/function_base.py:3163:
+	#	RuntimeWarning: invalid value encountered in true_divide
+	#	c /= stddev[:,None]
+
+	#	(and/or the same but with "c /= stddev[None, :]")
+
 	dcorrel=np.corrcoef(data.T)
 
Index: issm/trunk/src/m/qmu/helpers.py
===================================================================
--- issm/trunk/src/m/qmu/helpers.py	(revision 23389)
+++ issm/trunk/src/m/qmu/helpers.py	(revision 23394)
@@ -250,5 +250,5 @@
 		pass
 
-	# if all of that fails, then if is not empty
+	# if all of that fails, then it is not empty
 	return False
 
Index: issm/trunk/src/m/qmu/preqmu.py
===================================================================
--- issm/trunk/src/m/qmu/preqmu.py	(revision 23389)
+++ issm/trunk/src/m/qmu/preqmu.py	(revision 23394)
@@ -45,6 +45,7 @@
 			raise RuntimeError('Existing '+str(options.qmudir)+' directory, cannot overwrite. Specify "overwrite","y" option in solve arguments.')
 	
-
-	os.makedirs(qmudir)
+	# os.makedirs() raises error when dir exists, matlab's mkdir() does not
+	if not os.path.isdir(qmudir):
+		os.makedirs(qmudir)
 	os.chdir(qmudir)
 
Index: issm/trunk/src/m/qmu/process_qmu_response_data.m
===================================================================
--- issm/trunk/src/m/qmu/process_qmu_response_data.m	(revision 23389)
+++ issm/trunk/src/m/qmu/process_qmu_response_data.m	(revision 23394)
@@ -43,8 +43,6 @@
 	%ok, process the domains named in qmu_mass_flux_profiles,  to build a list of segments (MatArray)
 	md.qmu.mass_flux_segments=cell(num_mass_flux,1);
-	md.qmu.mass_flux_segments
 	for i=1:num_mass_flux,
 		md.qmu.mass_flux_segments{i}=MeshProfileIntersection(md.mesh.elements,md.mesh.x,md.mesh.y,[md.qmu.mass_flux_profile_directory '/' md.qmu.mass_flux_profiles{i}]);
 	end
-	md.qmu.mass_flux_segments
 end
Index: issm/trunk/src/wrappers/DistanceToMaskBoundary/DistanceToMaskBoundary.cpp
===================================================================
--- issm/trunk/src/wrappers/DistanceToMaskBoundary/DistanceToMaskBoundary.cpp	(revision 23389)
+++ issm/trunk/src/wrappers/DistanceToMaskBoundary/DistanceToMaskBoundary.cpp	(revision 23394)
@@ -43,5 +43,6 @@
 
 	/*Call core of computation: */
-	DistanceToMaskBoundaryx(&distance,x,y,mask,nods);
+	_error_("messing up with AD, is this fonction really used??");
+	//DistanceToMaskBoundaryx(&distance,x,y,mask,nods);
 
 	/*Write results: */
Index: issm/trunk/src/wrappers/IssmConfig/IssmConfig.cpp
===================================================================
--- issm/trunk/src/wrappers/IssmConfig/IssmConfig.cpp	(revision 23389)
+++ issm/trunk/src/wrappers/IssmConfig/IssmConfig.cpp	(revision 23394)
@@ -66,4 +66,14 @@
 	else if(strcmp(name,"_HAVE_M1QN3_")==0){
 		#ifdef _HAVE_M1QN3_
+		value = 1.;
+		#endif
+	}
+	else if(strcmp(name,"_HAVE_ADOLC_")==0){
+		#ifdef _HAVE_ADOLC_
+		value = 1.;
+		#endif
+	}
+	else if(strcmp(name,"_HAVE_CODIPACK_")==0){
+		#ifdef _HAVE_CODIPACK_
 		value = 1.;
 		#endif
Index: issm/trunk/src/wrappers/javascript/Makefile.am
===================================================================
--- issm/trunk/src/wrappers/javascript/Makefile.am	(revision 23389)
+++ issm/trunk/src/wrappers/javascript/Makefile.am	(revision 23394)
@@ -1,3 +1,3 @@
-AM_CPPFLAGS = @DAKOTAINCL@ @PETSCINCL@ @MPIINCL@ @SPOOLESINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @AMPIINCL@
+AM_CPPFLAGS = @DAKOTAINCL@ @PETSCINCL@ @MPIINCL@ @SPOOLESINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @AMPIINCL@ @ADJOINTMPIINCL@ @CODIPACKINCL@
 AUTOMAKE_OPTIONS = subdir-objects
 
Index: issm/trunk/src/wrappers/matlab/Makefile.am
===================================================================
--- issm/trunk/src/wrappers/matlab/Makefile.am	(revision 23389)
+++ issm/trunk/src/wrappers/matlab/Makefile.am	(revision 23394)
@@ -1,3 +1,3 @@
-AM_CPPFLAGS = @NEOPZINCL@ @DAKOTAINCL@ @MATLABINCL@ @PETSCINCL@ @MPIINCL@ @SPOOLESINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @AMPIINCL@
+AM_CPPFLAGS = @NEOPZINCL@ @DAKOTAINCL@ @MATLABINCL@ @PETSCINCL@ @MPIINCL@ @SPOOLESINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @AMPIINCL@ @ADJOINTMPIINCL@ @MEDIPACKINCL@ @CODIPACKINCL@
 AUTOMAKE_OPTIONS = subdir-objects
 
Index: issm/trunk/src/wrappers/python/Makefile.am
===================================================================
--- issm/trunk/src/wrappers/python/Makefile.am	(revision 23389)
+++ issm/trunk/src/wrappers/python/Makefile.am	(revision 23394)
@@ -1,3 +1,3 @@
-AM_CPPFLAGS = @DAKOTAINCL@ @PETSCINCL@ @MPIINCL@ @SPOOLESINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @PYTHONINCL@ @PYTHON_NUMPYINCL@ @AMPIINCL@
+AM_CPPFLAGS = @DAKOTAINCL@ @PETSCINCL@ @MPIINCL@ @SPOOLESINCL@ @METISINCL@ @TRIANGLEINCL@ @CHACOINCL@ @SCOTCHINCL@ @SHAPELIBINCL@ @PYTHONINCL@ @PYTHON_NUMPYINCL@ @AMPIINCL@ @ADJOINTMPIINCL@ @MEDIPACKINCL@ @CODIPACKINCL@
 AUTOMAKE_OPTIONS = subdir-objects
 
Index: issm/trunk/src/wrappers/python/io/FetchPythonData.cpp
===================================================================
--- issm/trunk/src/wrappers/python/io/FetchPythonData.cpp	(revision 23389)
+++ issm/trunk/src/wrappers/python/io/FetchPythonData.cpp	(revision 23394)
@@ -32,5 +32,5 @@
 	}
 	else if (PyInt_Check(py_float))
-	 dscalar=(double)PyInt_AsLong(py_float);
+		dscalar=(double)PyInt_AsLong(py_float);
 	else if (PyBool_Check(py_float))
 		dscalar=(double)PyLong_AsLong(py_float);
@@ -132,5 +132,6 @@
 	double* dmatrix=NULL;
 	double* matrix=NULL;
-	int M,N;
+	int M=0;
+	int N=0;
 	int ndim;
 	npy_intp*  dims=NULL;
@@ -236,5 +237,6 @@
 	/*output: */
 	int* matrix=NULL;
-	int M,N;
+	int M=0;
+	int N=0;
 	int ndim;
 	npy_intp*  dims=NULL;
@@ -325,5 +327,6 @@
 	bool* bmatrix=NULL;
 	bool* matrix=NULL;
-	int M,N;
+	int M=0;
+	int N=0;
 	int ndim;
 	npy_intp*  dims=NULL;
@@ -411,5 +414,5 @@
 	double* dvector=NULL;
 	double* vector=NULL;
-	int M;
+	int M=0;
 	int ndim;
 	npy_intp*  dims=NULL;
@@ -499,5 +502,5 @@
 	/*output: */
 	float* vector=NULL;
-	int M;
+	int M=0;
 	int ndim;
 	npy_intp*  dims=NULL;
@@ -539,5 +542,5 @@
 				/*transform into int vector: */
 				vector=xNew<float>(M);
-				for(i=0;i<M;i++)vector[i]=(float)lvector[i];
+				for(i=0;i<M;i++)vector[i]=(float)dvector[i];
 			}
 
@@ -566,5 +569,5 @@
 		}
 		else
-		 vector=NULL;
+			vector=NULL;
 	}
 	else{
@@ -584,5 +587,5 @@
 	/*output: */
 	int* vector=NULL;
-	int M;
+	int M=0;
 	int ndim;
 	npy_intp*  dims=NULL;
@@ -624,5 +627,5 @@
 				/*transform into int vector: */
 				vector=xNew<int>(M);
-				for(i=0;i<M;i++)vector[i]=(int)lvector[i];
+				for(i=0;i<M;i++)vector[i]=(int)dvector[i];
 			}
 
@@ -672,5 +675,5 @@
 	bool* bvector=NULL;
 	bool* vector=NULL;
-	int M;
+	int M=0;
 	int ndim;
 	npy_intp*  dims=NULL;
@@ -923,8 +926,88 @@
 	*pcontours=contours;
 }
-/*}}}*/
-void FetchChacoData(int* pnvtxs,int** padjacency,int** pstart,float** pewgts,PyObject* A_IN,PyObject* EWGTS_IN){
-	_error_("Nathan... I need your help here");
-}
+
+void FetchChacoData(int* pnvtxs,int** padjacency,int** pstart,float** pewgts,PyObject* A_IN, PyObject* EWGTS_IN){/*{{{*/
+
+	double* a = ((double*)PyArray_DATA((PyArrayObject*)A_IN));
+	int ndim  = PyArray_NDIM((PyArrayObject*)A_IN);
+	int nzmax = PyArray_CountNonzero((PyArrayObject*)A_IN);
+
+	/*Fetch adjacency matrix:*/
+	int      nvtxs       = PyArray_DIMS((PyArrayObject*)A_IN)[1];
+
+	int* mwstart = xNewZeroInit<int>(nvtxs+1);
+	pyGetJc(a,nvtxs,mwstart);
+
+	int* mwadjacency = xNewZeroInit<int>(nzmax);
+	pyGetIr(a,nvtxs,nzmax,mwadjacency);
+	
+	int* start = xNew<int>(nvtxs+1);
+	for(int i=0;i<nvtxs+1;i++) start[i]=(int)mwstart[i];
+	int* adjacency = xNew<int>(nzmax);
+	for(int i=0; i<nzmax; i++) adjacency[i]=(int)mwadjacency[i];
+
+	/*Get edges weights*/
+	int nedges = start[nvtxs];
+	float* ewgts = NULL;
+	int size = PyArray_SIZE((PyArrayObject*)EWGTS_IN);
+	//size may be 1 and still be empty;
+	//presumably size of edge_weights input will never be exactly 1
+	if(size != 1 && size != 0){
+		ewgts = xNewZeroInit<float>(nedges);
+		for(int i = 0; i<nedges;i++){
+			ewgts[i] = (float)a[i];
+		}
+	}
+
+	/*Assign output pointers*/
+	*pnvtxs     = nvtxs;
+	*padjacency = adjacency;
+	*pstart     = start;
+	*pewgts     = ewgts;
+}
+/*}}}*/
+
+void pyGetJc(double* a, int nvtxs, int* Jc){
+/*{{{*/
+	//get the number of non-zero elements in each row, adding to the prior number;
+	//always starts with 0 and has length: number_of_rows_in(a)+1 == nvtxs+1
+	// eg: 0, 1, 3, 6, 8, 13, ...
+	// for: 1 in the first row, 2 in the second, 3 in the third, etc.
+	int c = 0;
+	Jc[c++] = 0;
+
+	for(int i=0;i<nvtxs;i++){
+		for(int j=0;j<nvtxs;j++){
+			if ((int)a[i+(j*nvtxs)] != 0){
+				Jc[c] += 1;
+			}
+		}
+		c++;
+		Jc[c] = Jc[c-1];
+	}
+	return;
+}
+/*}}}*/
+
+void pyGetIr(double* a, int nvtxs, int nzmax, int* Ir){
+/*{{{*/
+	//get the row-wise position of each non-zero element;
+	//has length: number_of_non_zero_elements_in(a) == nzmax
+	// eg: 10, 24, 25, 4, ...
+	// the 10th, 24th, and 25th elements in the first row, the 4th in the second row
+	// using pyGetJc to determine which indices correspond to which row
+	int r = 0;
+
+	for(int i=0;i<nvtxs;i++){
+		for(int j=0;j<nvtxs;j++){
+			if ((int)a[i+(j*nvtxs)] != 0){
+				Ir[r] = j;
+				r++;
+			}
+		}
+	}
+	return;
+}
+/*}}}*/
 
 /*Python version dependent: */
